import i18n from 'i18next';
import { initReactI18next } from 'react-i18next';
import LanguageDetector from 'i18next-browser-languagedetector';
// 自編語言包
import en from './languages/en_US.json';
// import zh from './languages/zh_CN.json'
import pt from './languages/pt_BR.json';
import ru from './languages/ru_RU.json';
import es from './languages/es_MX.json';

const resources = {
    en: {
        key:"en_US",
        name:"English",
        translation: en,
    },
    // zh: {
    //     translation: zh
    // }
    pt:{
        key:"pt_BR",
        name:"Português",
        translation:pt
    },
    es:{
        key:"es_MX",
        name:"Español",
        translation:es
    },
    ru: {
        key:"ru_RU",
        name:"Русский",
        translation: ru,
    }
}
const dlang="en";

i18n
    .use(LanguageDetector)
    .use(initReactI18next)
    .init({
        compatibilityJSON: 'v3', // 对安卓进行兼容
        resources,
        fallbackLng: dlang, // 默认语言，也是设置语言时设置了不存在的语言时使用的
        interpolation: {
            escapeValue: false
        }
    }, (err) => {
        // 錯誤
        if (err) throw err;
        let language=i18n.language;
        if (language.indexOf("-"))language=language.split("-")[0];
        if (resources[language]==null)language=dlang;
        // 这里放多一层函数是为了方便之后切换语言的同时做一些其他的统一处理
        i18n.setLocalLanguage = function (value) {
            // 設置項目文本的語言
            this.changeLanguage(value);
            // 做点别的，比如同时切换别的插件的语言
        }
        // 初始化
        i18n.setLocalLanguage(language);
        i18n.old_t=i18n.t;
        i18n.t=(key)=>{
            let value=i18n.old_t(key);
            let DOLLAR=global.DOLLAR!=null?global.DOLLAR:"";
            let currency=global.currency!=null?global.currency:"";
            if (value!=null&&typeof value==="string"){
                value=value.replaceAll("{D}",DOLLAR);
                value=value.replaceAll("{C}",currency);
            }
            return value;
        }
    });
i18n.getCurrLang=()=>{
    let res=resources[i18n.language];
    if (res)return res.key;
    return "";
}
i18n.getCurrLangName=()=>{
    let res=resources[i18n.language];
    if (res)return res.name;
    return "";
}
i18n.getCurrLangKey=()=>{
    return i18n.getCurrLang().replace("_","-");
}
i18n.getAllLangs=()=>{
    let langs=[];
    for (const lkey in resources) {
        let lang=resources[lkey];
        langs.push(Object.assign({},{lkey:lkey},lang));
    }
    return langs;
}
//同步lang 从服务器
i18n.setLocalLangFromS=(language)=>{
    if (resources[language]==null)return;
    i18n.setLocalLanguage(language);
}
export default i18n;
